ENTRY(_start)
PHDRS {
  Head 1 FLAGS(1|4);
  Rom 1 FLAGS(1|4);
  Ram 1 FLAGS(2|4);
  Tls 7 FLAGS(2|4);
  Bss 1 FLAGS(2|4);
  stack 0x6474e551 FLAGS(2|4);
}
SECTIONS {
  .head SEGMENT_START("text-segment", 0x400000) : AT(0x2000) {
    HIDDEN(_base = .);
    KEEP(*(.head))
    KEEP(*(.apesh))
    KEEP(*(.head2))
    KEEP(*(.text.head))
    . = ALIGN(8);
    HIDDEN(ape_phdrs = .);
    KEEP(*(.elf.phdrs))
    HIDDEN(ape_phdrs_end = .);
    . = ALIGN(8);
    HIDDEN(ape_note = .);
    KEEP(*(.note.openbsd.ident))
    KEEP(*(.note.netbsd.ident))
    HIDDEN(ape_note_end = .);
    KEEP(*(.pe.header))
    HIDDEN(ape_pe_sections = .);
    KEEP(*(.pe.sections))
    HIDDEN(ape_pe_sections_end = .);
    KEEP(*(.macho))
    . = ALIGN(8);
    HIDDEN(ape_macho_end = .);
    KEEP(*(.ape.pad.head))
    . = ALIGN(((1 & 4) == 4) || ((1 & 2) == 2) ? 0x1000 : 16);
    HIDDEN(_ehead = .);
  } :Head
  .text . : {
    BYTE(0x90)
    *(.text.real)
    KEEP(*(SORT_BY_NAME(.sort.text.real.*)))
    KEEP(*(.ape.loader))
    HIDDEN(_ereal = .);
    . += 1;
    *(.start)
    KEEP(*(.initprologue))
    KEEP(*(SORT_BY_NAME(.init.*)))
    KEEP(*(.init))
    KEEP(*(.initepilogue))
    KEEP(*(.pltprologue))
    *(.plt)
    KEEP(*(.pltepilogue))
    KEEP(*(.pltgotprologue))
    *(.plt.got)
    KEEP(*(.pltgotepilogue))
    *(.text.startup .text.startup.*)
    *(.text.exit .text.exit.*)
    *(.text.unlikely .text.*_unlikely .text.unlikely.*)
    *(SORT_BY_ALIGNMENT(.text.antiquity))
    *(SORT_BY_ALIGNMENT(.text.antiquity.*))
    KEEP(*(.textwindowsprologue))
    *(.text.windows)
    KEEP(*(.textwindowsepilogue))
    *(SORT_BY_ALIGNMENT(.text.modernity))
    *(SORT_BY_ALIGNMENT(.text.modernity.*))
    *(SORT_BY_ALIGNMENT(.text.hot))
    *(SORT_BY_ALIGNMENT(.text.hot.*))
    KEEP(*(.keep.text))
    *(.text .stub .text.*)
    KEEP(*(SORT_BY_NAME(.sort.text.*)))
    KEEP(*(.ape.pad.test));
    *(.test.unlikely)
    *(.test .test.*)
    KEEP(*(.ape.pad.privileged));
    . += . > 0 ? 1 : 0;
    HIDDEN(__privileged_start = .);
    . += . > 0 ? 1 : 0;
    *(.privileged)
    HIDDEN(__privileged_end = .);
    . += . > 0 ? 1 : 0;
    KEEP(*(.ape.pad.rodata));
    KEEP(*(.rodata.pytab.0));
    KEEP(*(.rodata.pytab.1));
    KEEP(*(.rodata.pytab.2));
    *(.rodata .rodata.*)
    *(.ubsan.types)
    *(.ubsan.data)
    KEEP(*(.commentprologue))
    KEEP(*(.comment))
    KEEP(*(.commentepilogue))
    KEEP(*(.idata.ro));
    KEEP(*(SORT_BY_NAME(.idata.ro.*)))
    . = ALIGN(8);
    PROVIDE_HIDDEN(__init_array_start = .);
    KEEP(*(SORT_BY_INIT_PRIORITY(.init_array.*)
           SORT_BY_INIT_PRIORITY(.ctors.*)))
    KEEP(*(.ctors))
    KEEP(*(.init_array))
    KEEP(*(.preinit_array))
    PROVIDE_HIDDEN(__init_array_end = .);
    . = ALIGN(8);
    PROVIDE_HIDDEN(__fini_array_start = .);
    KEEP(*(SORT_BY_INIT_PRIORITY(.fini_array.*)
           SORT_BY_INIT_PRIORITY(.dtors.*)))
    KEEP(*(.dtors))
    PROVIDE_HIDDEN(__fini_array_end = .);
    KEEP(*(.initroprologue))
    KEEP(*(SORT_BY_NAME(.initro.*)))
    KEEP(*(.initroepilogue))
    KEEP(*(SORT_BY_NAME(.sort.rodata.*)))
    KEEP(*(.ape.pad.text))
    . = ALIGN(0x1000);
    HIDDEN(_etext = .);
    PROVIDE_HIDDEN(etext = .);
  } :Rom
  .data ALIGN(0x1000) : {
    KEEP(*(SORT_BY_NAME(.piro.data.sort.iat.*)))
    KEEP(*(.dataprologue))
    *(.data .data.*)
    KEEP(*(SORT_BY_NAME(.sort.data.*)))
    . += . > 0 ? 1 : 0;
    KEEP(*(.gotprologue))
    *(.got)
    KEEP(*(.gotepilogue))
    KEEP(*(.gotpltprologue))
    *(.got.plt)
    KEEP(*(.gotpltepilogue))
    . = ALIGN(8);
    KEEP(*(SORT_BY_NAME(.piro.relo.sort.*)))
    PROVIDE_HIDDEN(__relo_end = .);
    . = ALIGN(8);
    KEEP(*(SORT_BY_NAME(.piro.data.sort.*)))
    KEEP(*(.piro.pad.data))
    KEEP(*(.dataepilogue))
    HIDDEN(_edata = .);
    PROVIDE_HIDDEN(edata = .);
    KEEP(*(SORT_BY_NAME(.zip.*)))
    HIDDEN(_ezip = .);
  } :Ram
  .tdata . : {
    _tdata_start = .;
    *(SORT_BY_ALIGNMENT(.tdata))
    *(SORT_BY_ALIGNMENT(.tdata.*))
    . = ALIGN(16);
    _tdata_end = .;
    . = ALIGN(0x1000);
  } :Tls
  . = ALIGN(0x1000);
  .tbss . : {
    _tbss_start = .;
    *(SORT_BY_ALIGNMENT(.tbss))
    *(SORT_BY_ALIGNMENT(.tbss.*))
    . = ALIGN(16);
    _tbss_end = .;
  } :Tls
  .bss ALIGN(64) : {
    KEEP(*(.bssprologue))
    KEEP(*(SORT_BY_NAME(.piro.bss.init.*)))
    *(.piro.bss)
    KEEP(*(SORT_BY_NAME(.piro.bss.sort.*)))
    HIDDEN(__piro_end = .);
    . += . > 0 ? 1 : 0;
    *(SORT_BY_ALIGNMENT(.bss))
    *(SORT_BY_ALIGNMENT(.bss.*))
    *(COMMON)
    KEEP(*(SORT_BY_NAME(.sort.bss.*)))
    KEEP(*(.bssepilogue))
    . = ALIGN(0x10000);
    HIDDEN(_end = .);
    PROVIDE_HIDDEN(end = .);
  } :Bss
  .shstrtab : { *(.shstrtab) }
  .strtab : { *(.strtab) }
  .symtab : { *(.symtab) }
  .stab 0 : { *(.stab) }
  .stabstr 0 : { *(.stabstr) }
  .stab.excl 0 : { *(.stab.excl) }
  .stab.exclstr 0 : { *(.stab.exclstr) }
  .stab.index 0 : { *(.stab.index) }
  .stab.indexstr 0 : { *(.stab.indexstr) }
  .comment 0 : { *(.comment) }
  .debug 0 : { *(.debug) }
  .line 0 : { *(.line) }
  .debug_srcinfo 0 : { *(.debug_srcinfo) }
  .debug_sfnames 0 : { *(.debug_sfnames) }
  .debug_aranges 0 : { *(.debug_aranges) }
  .debug_pubnames 0 : { *(.debug_pubnames) }
  .debug_info 0 : { *(.debug_info .gnu.linkonce.wi.*) }
  .debug_abbrev 0 : { *(.debug_abbrev) }
  .debug_line 0 : { *(.debug_line .debug_line.* .debug_line_end ) }
  .debug_frame 0 : { *(.debug_frame) }
  .debug_str 0 : { *(.debug_str) }
  .debug_loc 0 : { *(.debug_loc) }
  .debug_macinfo 0 : { *(.debug_macinfo) }
  .debug_weaknames 0 : { *(.debug_weaknames) }
  .debug_funcnames 0 : { *(.debug_funcnames) }
  .debug_typenames 0 : { *(.debug_typenames) }
  .debug_varnames 0 : { *(.debug_varnames) }
  .debug_pubtypes 0 : { *(.debug_pubtypes) }
  .debug_ranges 0 : { *(.debug_ranges) }
  .debug_macro 0 : { *(.debug_macro) }
  .debug_addr 0 : { *(.debug_addr) }
  .gnu.attributes 0 : { KEEP(*(.gnu.attributes)) }
  .GCC.command.line 0 : { *(.GCC.command.line) }
  /DISCARD/ : {
    *(__mcount_loc)
    *(.discard)
    *(.yoink)
    *(.*)
  }
}
HIDDEN(ape_elf_entry = (_start)); HIDDEN(ape_elf_entry_bcs0 = (((((((_start) >> ((0)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((_start) >> ((0)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((_start) >> ((0)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_entry_bcs1 = (((((((_start) >> ((1)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((_start) >> ((1)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((_start) >> ((1)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_entry_bcs2 = (((((((_start) >> ((2)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((_start) >> ((2)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((_start) >> ((2)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_entry_bcs3 = (((((((_start) >> ((3)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((_start) >> ((3)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((_start) >> ((3)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_entry_bcs4 = (((((((_start) >> ((4)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((_start) >> ((4)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((_start) >> ((4)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_entry_bcs5 = (((((((_start) >> ((5)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((_start) >> ((5)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((_start) >> ((5)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_entry_bcs6 = (((((((_start) >> ((6)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((_start) >> ((6)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((_start) >> ((6)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_entry_bcs7 = (((((((_start) >> ((7)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((_start) >> ((7)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((_start) >> ((7)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c));
HIDDEN(ape_elf_phoff = (((ape_phdrs) - (0x400000)))); HIDDEN(ape_elf_phoff_bcs0 = (((((((((ape_phdrs) - (0x400000))) >> ((0)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((((ape_phdrs) - (0x400000))) >> ((0)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((((ape_phdrs) - (0x400000))) >> ((0)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_phoff_bcs1 = (((((((((ape_phdrs) - (0x400000))) >> ((1)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((((ape_phdrs) - (0x400000))) >> ((1)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((((ape_phdrs) - (0x400000))) >> ((1)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_phoff_bcs2 = (((((((((ape_phdrs) - (0x400000))) >> ((2)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((((ape_phdrs) - (0x400000))) >> ((2)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((((ape_phdrs) - (0x400000))) >> ((2)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_phoff_bcs3 = (((((((((ape_phdrs) - (0x400000))) >> ((3)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((((ape_phdrs) - (0x400000))) >> ((3)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((((ape_phdrs) - (0x400000))) >> ((3)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_phoff_bcs4 = (((((((((ape_phdrs) - (0x400000))) >> ((4)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((((ape_phdrs) - (0x400000))) >> ((4)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((((ape_phdrs) - (0x400000))) >> ((4)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_phoff_bcs5 = (((((((((ape_phdrs) - (0x400000))) >> ((5)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((((ape_phdrs) - (0x400000))) >> ((5)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((((ape_phdrs) - (0x400000))) >> ((5)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_phoff_bcs6 = (((((((((ape_phdrs) - (0x400000))) >> ((6)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((((ape_phdrs) - (0x400000))) >> ((6)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((((ape_phdrs) - (0x400000))) >> ((6)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_phoff_bcs7 = (((((((((ape_phdrs) - (0x400000))) >> ((7)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((((ape_phdrs) - (0x400000))) >> ((7)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((((ape_phdrs) - (0x400000))) >> ((7)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c));
HIDDEN(ape_elf_shoff = (0)); HIDDEN(ape_elf_shoff_bcs0 = (((((((0) >> ((0)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((0) >> ((0)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((0) >> ((0)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_shoff_bcs1 = (((((((0) >> ((1)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((0) >> ((1)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((0) >> ((1)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_shoff_bcs2 = (((((((0) >> ((2)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((0) >> ((2)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((0) >> ((2)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_shoff_bcs3 = (((((((0) >> ((3)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((0) >> ((3)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((0) >> ((3)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_shoff_bcs4 = (((((((0) >> ((4)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((0) >> ((4)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((0) >> ((4)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_shoff_bcs5 = (((((((0) >> ((5)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((0) >> ((5)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((0) >> ((5)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_shoff_bcs6 = (((((((0) >> ((6)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((0) >> ((6)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((0) >> ((6)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_shoff_bcs7 = (((((((0) >> ((7)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((0) >> ((7)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((0) >> ((7)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c));
HIDDEN(ape_elf_phnum = ((ape_phdrs_end - ape_phdrs) / 56)); HIDDEN(ape_elf_phnum_bcs0 = ((((((((ape_phdrs_end - ape_phdrs) / 56) >> ((0)*8)) >> 0)&0x7) + 0x30) << 24) | (((((((ape_phdrs_end - ape_phdrs) / 56) >> ((0)*8)) >> 3)&0x7) + 0x30) << 16) | ((((((((ape_phdrs_end - ape_phdrs) / 56) >> ((0)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_phnum_bcs1 = ((((((((ape_phdrs_end - ape_phdrs) / 56) >> ((1)*8)) >> 0)&0x7) + 0x30) << 24) | (((((((ape_phdrs_end - ape_phdrs) / 56) >> ((1)*8)) >> 3)&0x7) + 0x30) << 16) | ((((((((ape_phdrs_end - ape_phdrs) / 56) >> ((1)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_phnum_bcs2 = ((((((((ape_phdrs_end - ape_phdrs) / 56) >> ((2)*8)) >> 0)&0x7) + 0x30) << 24) | (((((((ape_phdrs_end - ape_phdrs) / 56) >> ((2)*8)) >> 3)&0x7) + 0x30) << 16) | ((((((((ape_phdrs_end - ape_phdrs) / 56) >> ((2)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_phnum_bcs3 = ((((((((ape_phdrs_end - ape_phdrs) / 56) >> ((3)*8)) >> 0)&0x7) + 0x30) << 24) | (((((((ape_phdrs_end - ape_phdrs) / 56) >> ((3)*8)) >> 3)&0x7) + 0x30) << 16) | ((((((((ape_phdrs_end - ape_phdrs) / 56) >> ((3)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c));
HIDDEN(ape_elf_shnum = (0)); HIDDEN(ape_elf_shnum_bcs0 = (((((((0) >> ((0)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((0) >> ((0)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((0) >> ((0)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_shnum_bcs1 = (((((((0) >> ((1)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((0) >> ((1)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((0) >> ((1)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_shnum_bcs2 = (((((((0) >> ((2)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((0) >> ((2)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((0) >> ((2)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_shnum_bcs3 = (((((((0) >> ((3)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((0) >> ((3)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((0) >> ((3)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c));
HIDDEN(ape_elf_shstrndx = (0)); HIDDEN(ape_elf_shstrndx_bcs0 = (((((((0) >> ((0)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((0) >> ((0)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((0) >> ((0)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_shstrndx_bcs1 = (((((((0) >> ((1)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((0) >> ((1)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((0) >> ((1)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_shstrndx_bcs2 = (((((((0) >> ((2)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((0) >> ((2)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((0) >> ((2)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c)); HIDDEN(ape_elf_shstrndx_bcs3 = (((((((0) >> ((3)*8)) >> 0)&0x7) + 0x30) << 24) | ((((((0) >> ((3)*8)) >> 3)&0x7) + 0x30) << 16) | (((((((0) >> ((3)*8))&0xff) >> 6)&0x7) + 0x30) << 8) | 0x5c));
HIDDEN(_tdata_size = _tdata_end - _tdata_start);
HIDDEN(_tls_size = _tbss_end - _tdata_start);
HIDDEN(_tls_content = (_tdata_end - _tdata_start) + (_tbss_end - _tbss_start));
HIDDEN(__privileged_addr = ((__privileged_start) & -(0x1000)));
HIDDEN(__privileged_size = ((((__privileged_end) + (0x1000)-1) & -(0x1000)) -
                            ((__privileged_start) & -(0x1000))));
HIDDEN(ape_rom_offset = 0);
HIDDEN(ape_rom_vaddr = ADDR(.head));
HIDDEN(ape_rom_paddr = LOADADDR(.head));
HIDDEN(ape_rom_filesz = LOADADDR(.data) - ape_rom_paddr);
HIDDEN(ape_rom_memsz = ADDR(.data) - ADDR(.head));
HIDDEN(ape_rom_align = 0x1000);
HIDDEN(ape_rom_rva = ((ape_rom_vaddr) - (0x400000)));
HIDDEN(ape_ram_offset = ape_rom_offset + ape_rom_filesz);
HIDDEN(ape_ram_vaddr = ADDR(.data));
HIDDEN(ape_ram_paddr = LOADADDR(.data));
HIDDEN(ape_ram_filesz = SIZEOF(.data) + SIZEOF(.tdata));
HIDDEN(ape_ram_memsz = ADDR(.bss) + SIZEOF(.bss) - ape_ram_vaddr);
HIDDEN(ape_ram_align = 0x1000);
HIDDEN(ape_ram_rva = ((ape_ram_vaddr) - (0x400000)));
HIDDEN(ape_stack_pf = DEFINED(ape_stack_pf) ? ape_stack_pf : 4 | 2);
HIDDEN(ape_stack_prot = ((4 & (ape_stack_pf)) >> 2 | (2 & (ape_stack_pf)) | (1 & (ape_stack_pf)) << 2));
HIDDEN(ape_stack_offset = ape_ram_offset + ape_ram_filesz);
HIDDEN(ape_stack_vaddr = DEFINED(ape_stack_vaddr) ? ape_stack_vaddr : 0x700000000000);
HIDDEN(ape_stack_paddr = ape_ram_paddr + ape_ram_filesz);
HIDDEN(ape_stack_filesz = 0);
HIDDEN(ape_stack_memsz = DEFINED(ape_stack_memsz) ? ape_stack_memsz : 0x20000);
HIDDEN(ape_stack_align = 16);
HIDDEN(ape_note_offset = ape_rom_offset + (ape_note - ape_rom_vaddr));
HIDDEN(ape_note_vaddr = ape_note);
HIDDEN(ape_note_paddr = ape_rom_paddr + ape_note_offset);
HIDDEN(ape_note_filesz = ape_note_end - ape_note);
HIDDEN(ape_note_memsz = ape_note_filesz);
HIDDEN(ape_note_align = 8);
HIDDEN(ape_text_offset = ape_rom_offset + LOADADDR(.text) - ape_rom_paddr);
HIDDEN(ape_text_paddr = LOADADDR(.text));
HIDDEN(ape_text_vaddr = ADDR(.text));
HIDDEN(ape_text_filesz = SIZEOF(.text));
HIDDEN(ape_text_memsz = SIZEOF(.text));
HIDDEN(ape_text_align = 0x1000);
HIDDEN(ape_text_rva = ((ape_text_vaddr) - (0x400000)));
HIDDEN(ape_data_offset = ape_ram_offset + LOADADDR(.data) - ape_ram_paddr);
HIDDEN(ape_data_paddr = LOADADDR(.data));
HIDDEN(ape_data_vaddr = ADDR(.data));
HIDDEN(ape_data_filesz = SIZEOF(.data) + SIZEOF(.tdata));
HIDDEN(ape_data_memsz = SIZEOF(.data) + SIZEOF(.tdata));
HIDDEN(ape_data_align = 0x1000);
HIDDEN(ape_data_rva = ((ape_data_vaddr) - (0x400000)));
HIDDEN(ape_bss_offset = ape_ram_offset + LOADADDR(.bss) - ape_ram_paddr);
HIDDEN(ape_bss_paddr = LOADADDR(.bss));
HIDDEN(ape_bss_vaddr = ADDR(.bss));
HIDDEN(ape_bss_filesz = 0);
HIDDEN(ape_bss_memsz = SIZEOF(.bss));
HIDDEN(ape_bss_align = 0x1000);
HIDDEN(ape_loader_dd_skip_bcs0 = ((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) < 10000 ? 0x20202020 : (DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) < 100000 ? 0x30202020 + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) / 10000 % 10) << 24) : (DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) < 1000000 ? 0x30302020 + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) / 10000 % 10) << 24) + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) / 100000 % 10) << 16) : (DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) < 10000000 ? 0x30303020 + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) / 10000 % 10) << 24) + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) / 100000 % 10) << 16) + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) / 1000000 % 10) << 8) : (DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) < 100000000 ? 0x30303030 + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) / 10000 % 10) << 24) + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) / 100000 % 10) << 16) + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) / 1000000 % 10) << 8) + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) / 10000000 % 10) << 0) : 0xffffffffffffffff)); HIDDEN(ape_loader_dd_skip_bcs1 = ((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) == 0 ? 0x20202030 : (DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) < 10 ? 0x30202020 + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) % 10) << 24) : (DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) < 100 ? 0x30302020 + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) % 10) << 24) + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) / 10 % 10) << 16) : (DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) < 1000 ? 0x30303020 + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) % 10) << 24) + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) / 10 % 10) << 16) + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) / 100 % 10) << 8) : 0x30303030 + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) % 10) << 24) + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) / 10 % 10) << 16) + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) / 100 % 10) << 8) + (((DEFINED(ape_loader) ? ((ape_loader) - (0x400000)) / 64 : 0) / 1000 % 10) << 0)));
HIDDEN(ape_loader_dd_count_bcs0 = ((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) < 10000 ? 0x20202020 : (DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) < 100000 ? 0x30202020 + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) / 10000 % 10) << 24) : (DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) < 1000000 ? 0x30302020 + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) / 10000 % 10) << 24) + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) / 100000 % 10) << 16) : (DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) < 10000000 ? 0x30303020 + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) / 10000 % 10) << 24) + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) / 100000 % 10) << 16) + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) / 1000000 % 10) << 8) : (DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) < 100000000 ? 0x30303030 + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) / 10000 % 10) << 24) + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) / 100000 % 10) << 16) + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) / 1000000 % 10) << 8) + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) / 10000000 % 10) << 0) : 0xffffffffffffffff)); HIDDEN(ape_loader_dd_count_bcs1 = ((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) == 0 ? 0x20202030 : (DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) < 10 ? 0x30202020 + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) % 10) << 24) : (DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) < 100 ? 0x30302020 + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) % 10) << 24) + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) / 10 % 10) << 16) : (DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) < 1000 ? 0x30303020 + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) % 10) << 24) + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) / 10 % 10) << 16) + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) / 100 % 10) << 8) : 0x30303030 + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) % 10) << 24) + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) / 10 % 10) << 16) + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) / 100 % 10) << 8) + (((DEFINED(ape_loader_end) ? (((ape_loader_end - ape_loader) + (0x1000)-1) & -(0x1000)) / 64 : 0) / 1000 % 10) << 0)));
HIDDEN(v_zip_cdoffset = DEFINED(__zip_start) ? __zip_start - 0x400000 : 0);;
HIDDEN(v_zip_cdirsize = DEFINED(__zip_start) ? __zip_end - __zip_start : 0);;
ASSERT(v_zip_cdirsize % 294 == 0, "bad zip cdir");
HIDDEN(v_zip_records = DEFINED(__zip_start) ? v_zip_cdirsize / 294 : 0);;
HIDDEN(v_zip_commentsize = DEFINED(__zip_start) ? _ezip - __zip_end - 22 : 0);;
ASSERT(DEFINED(ape_mz) ? ape_mz == 0x400000 : 1, "linker panic");
ASSERT((DEFINED(__init_bss_end) ? __init_bss_end : 0) % 8 == 0,
       "__init_bss misalign");
ASSERT(((DEFINED(__init_rodata_end) ? __init_rodata_end : 0) %
        8 == 0),
       "__init_rodata misalign");
ASSERT((!DEFINED(ape_grub) ? 1 : ((ape_grub) - (0x400000)) < 8192),
       "grub stub needs to be in first 8kb of image");
ASSERT(DEFINED(_start) || DEFINED(_start16),
       "please link a _start() or _start16() entrypoint");
ASSERT(!DEFINED(_start16) || ((_end) - (0x400000 - 0x2000)) < 65536,
       "ape won't support non-tiny real mode programs");
ASSERT((!((ape_stack_memsz) & ((ape_stack_memsz)-1))),
       "ape_stack_memsz must be a two power");
ASSERT(!(ape_stack_vaddr & (ape_stack_memsz - 1)),
       "ape_stack_vaddr must have ape_stack_memsz alignment; try using STATIC_STACK_ADDR(0x700000000000 - ape_stack_memsz);");
